#!/usr/bin/python
# -*- mode:python; coding:utf-8; tab-width:4 -*-

import sys

import Ice
Ice.loadSlice('-I {} cannon.ice'.format(Ice.getSliceDir()))
import Cannon
from matrix_utils import matrix_multiply

class ProcessorI(Cannon.Processor):
    def init(self, index, order, above, left, target, current=None):
        self.index=index
		self.order=order
		self.above=above
		self.left=left
		self.target=target
		self.MatrizA= Cannon.Matrix 
		self.MatrizB= Cannon.Matrix

	

    def injectA(self, A, step, current=None):
        self.MatrizA = A
		
		if(hasattr(self.MatrizB,"data")):
			self.multiplicar(step)

    def injectB(self, B, step, current=None):
        self.MatrizB = B

		if(hasattr(self.MatrizA,"data")):
			self.multiplicar(step)

	def multiplicar(self, step):
		self.Resultado=matrix_multiply(self.MatrizA, self.MatrizB)
		self.target.inject(self.index,self.Resultado)


class Server(Ice.Application):
    def run(self, args):
        broker = self.communicator()
        servant = ProcessorI()

        adapter = broker.createObjectAdapter('ProcessorAdapter')
        proxy = adapter.addWithUUID(servant)

        print('processor ready: "{}"'.format(proxy))

        adapter.activate()
        self.shutdownOnInterrupt()
        broker.waitForShutdown()


if __name__ == '__main__':
    app = Server()
    sys.exit(app.main(sys.argv))
